PING(8)

NAZWA
ping - wysyła pakiety ICMP ECHO_REQUEST do hostów sieciowych

SKŁADNIA

ping [-aAbBdCDefhLnOqrRUvV46] [-c liczba] [-F przepływu] [-i interwał] [-I interfejs] [-l liczba-pakietów] [-m cznik] [-M opcja-pmtudisc] [-N nodeinfo_option] [-w deadline] [-W timeout] [-p wzorzec] [-Q tos] [-s rozmiar-pakietu] [-S sndbuf] [-t ttl] [-T opcja-znacznika-czasu] [hop...] {cel}

OPIS

ping uses the ICMP protocol's mandatory ECHO_REQUEST datagram to elicit an ICMP ECHO_RESPONSE from a host or gateway. ECHO_REQUEST datagrams (“pings”) have an IP and ICMP header, followed by a struct timeval and then an arbitrary number of “pad” bytes used to fill out the packet.

ping works with both IPv4 and IPv6. Using only one of them explicitly can be enforced by specifying -4 or -6.

ping can also send IPv6 Node Information Queries (RFC4620). Intermediate hops may not be allowed, because IPv6 source routing was deprecated (RFC5095).

OPCJE

-4
    Use IPv4 only.

-6
    Use IPv6 only.

-a
    Ping dźwiękowy.

-A
    Adaptive ping. Interpacket interval adapts to round-trip time, so that effectively not more than one (or more, if preload is set) unanswered probe is present in the network. Minimal interval is 200msec unless super-user. On networks with low RTT this mode is essentially equivalent to flood mode.

-b
    Pozwala na wysyłanie pingów na adresy rozgłoszeniowe.

-B
    Nie pozwala programowi ping zmieniać źródłowego adresu wysyłanych pakietów. Adres jest przypisywany do wyboru dokonanego przy starcie programu.

-c liczba
    Kończy po wysłaniu liczby pakietów ECHO_REQUEST. Z podanym limitem program ping czeka na liczbę pakietów ECHO_RESPONSE, aż do czasu upłynięcia limitu.

-C
    Call connect() syscall on socket creation.

-d
    Ustawia opcję SO_DEBUG na używanym gnieździe. Ta opcja gniazda nie jest używana przez jądro Linux.

-e
    Set the identification field of ECHO_REQUEST. Value 0 implies using raw socket (not supported on ICMP datagram socket). The value of the field may be printed with -v option.

-D
    Wypisuje znacznik czasowy (w czasie uniksa + mikrosekundy jak w gettimeofday) przed każdym wierszem.

-f
    Flood ping. For every ECHO_REQUEST sent a period “.” is printed, while for every ECHO_REPLY received a backspace is printed. This provides a rapid display of how many packets are being dropped. If interval is not given, it sets interval to zero and outputs packets as fast as they come back or one hundred times per second, whichever is more. Only the super-user may use this option with zero interval.

-F etykieta przepływu
    Tylko IPv6. Przypisuje i ustawia 20-bitową etykietę przepływu (szesnastkowo) w pakietach żądania odpowiedzi. Jeśli wartość wynosi zero, jądro przypisuje losową etykietę przepływu.

-h
    Wyświetla pomoc.

-i interwał
    Wait interval seconds between sending each packet. Real number allowed with dot as a decimal separator (regardless locale setup). The default is to wait for one second between each packet normally, or not to wait in flood mode. Only super-user may set interval to values less than 2 ms.

-I interfejs
    interface is either an address, an interface name or a VRF name. If interface is an address, it sets source address to specified interface address. If interface is an interface name, it sets source interface to specified interface. If interface is a VRF name, each packet is routed using the corresponding routing table; in this case, the -I option can be repeated to specify a source address. NOTE: For IPv6, when doing ping to a link-local scope address, link specification (by the '%'-notation in destination, or by this option) can be used but it is no longer required.

-L liczba-pakietów
    Jeśli podana jest liczba-pakietów, ping wysyła tyle pakietów, nie czekając na odpowiedź, po czym przechodzi do normalnego trybu działania. Tylko użytkownik z uprawnieniami administratora może wybrać więcej niż 3 pakiety.

-L
    Uniemożliwia powracanie zapętlonych pakietów rozgłoszeniowych. Opcja ta ma znaczenie jedynie gdy adresem docelowym jest adres rozgłoszeniowy.

-m znacznik
    Używa znacznika do oznaczenia wychodzących pakietów. Jest to przydatne w wielu przypadkach dotyczących jądra, takich jak używanie zasad trasowania do wybrania określonego przetwarzania danych wychodzących.

-M opcje-pmtudisc
    Wybiera strategię Path MTU Discovery (badania MTU ścieżki). opcja-pmtudisc może być jedną z następujących: do (zapobiega fragmentacji, nawet lokalnej), want (wykonuje badanie MTU ścieżki, następuje lokalna fragmentacja gdy rozmiary pakietów są znaczne) lub dont (nie ustawia flagi DF).

-N opcje-nodeinfo
    IPv6 only. Send ICMPv6 Node Information Queries (RFC4620), instead of Echo Request. CAP_NET_RAW capability is required.

    help
        Pokazuje pomoc do obsługi NI.

    name
        Zapytania nazw węzłów.

    ipv6
        Zapytania adresów IPv6. Istnieje kilka flag dotyczących wyłącznie IPv6.

        ipv6-global
            Żądania adresów globalnych IPv6.

        ipv6-sitelocal
            Żądania adresów lokalnych IPv6.

        ipv6-linklocal
            Żądania adresów lokalnych dla łącza IPv6.

        ipv6-all
            Żądanie adresów IPv6 na innych interfejsach.

    ipv4
        Żądanie adresów IPv4. Istnieje jedna flaga dotycząca wyłącznie IPv4.

        ipv4-all
            Żądanie adresów IPv4 na innych interfejsach.

    subject-ipv6=adres-ipv6
        Przedmiotowy adres IPv6.

    subject-ipv4=adres-ipv4
        Przedmiotowy adres IPv4.

    subject-name=nazwa-węzła
        Przedmiotowa nazwa. Jeśli zawiera więcej niż jedną kropkę, zakłada się że jest to pełna, jednoznaczna nazwa domenowa (FQDN)6.

    subject-fqdn=nazwa-węzła
        Przedmiotowa nazwa. Zawsze zakłada się że jest to pełna, jednoznaczna nazwa domenowa (FQDN).

-n
    Tylko wyjście numeryczne. Nie będą dokonywane próby odczytania nazw symbolicznych adresów hostów.

-O
    Zgłasza bieżącą odpowiedź ICMP ECHO przed wysyłaniem następnego pakietu. Jest to przydatne razem ze znacznikiem czasu -D do zapisywania wyniku programu do pliku diagnostycznego w celu wyszukania brakujących odpowiedzi.

-p etykieta
    Można podać do 16 bajtów "wypełnienia" wysyłanego pakietu. Jest to przydatne do diagnozowania w sieci problemów związanych z danymi. Np. -p ff spowoduje wysyłanie pakietu wypełnionego jedynkami.

-q
    Ciche wyjście. Poza wierszami podsumowania na starcie/końcu nic nie jest wyświetlane.

-Q tos
    Ustawia bity związane z funkcją Quality of Service (jakość usługi). tos może być liczbą dziesiętną (tylko ping) lub szesnastkową.

    W RFC2474, pola te są interpretowane jako ośmiobitowe Differentiated Service (DS), składające się z : bitów 0-1 (2 najniższe bity) oddzielnych danych i bity 2-7 (najwyższe 6 bitów) Differentiated Services Codepoint (DSCP). W RFC2481 i RFC3168 bity 0-1 są używane do ECN.

    Historycznie (RFC1349, zastąpione przez RFC2474) były one interpretowane jako: bit 0 (najniższy) - zarezerwowany (obecnie: kontrola ograniczenia przesyłu), 1-4 jako Type of Service (typ usługi), a bity 5-7 (najwyższe) jako Precedence (pierwszeństwo).

-r
    Pomija normalne tabele trasowania i wysyła pakiety bezpośrednio do hosta w przyłączonej sieci. Jeśli host nie jest w sieci podłączonej bezpośrednio, zwracany jest błąd. Opcja ta może być używana do pingowania hosta lokalnego poprzez interfejs, przez który nie ma trasy, o ile użyto również opcji -I.

-R
    Tylko program ping. Nagrywa trasę. Zawiera w pakiecie ECHO_REQUEST opcję RECORD_ROUTE i wyświetla bufor trasy zwróconych pakietów. Proszę zauważyć, że nagłówek IP wystarcza jedynie na 9 takich tras. Wiele hostów ignoruje lub zarzuca tę opcję.

-s rozmiar-pakietu
    Określa liczbę wysyłanych bajtów danych. Domyślną wartością jest 56, co tłumaczy się na 64 bajty ICMP po połączeniu z 8 bajtami nagłówka ICMP.

-S sndbuf
    Ustawia sndbuf gniazda. Jeśli nie określono dokładniej, buforowany jest nie więcej niż jeden pakiet.

-t ttl
    Tylko ping. Ustawia TTL (IP Time to Live).

-T opcje znacznika-czasu
    Ustawia specjalne opcje znacznika czasu IP. opcje znacznika-czasu mogą przyjąć jedną z następujących wartości: tsonly (tylko znaczniki czasu), tsandaddr (znaczniki czasu i adresy) lub tsprespec host1 [host2 [host3 [host4]]] (wstępnie określone przeskoki znacznika czasu).

-U
    Wypisuje pełne opóźnienie użytkownik-użytkownik (stare zachowanie). ping wypisuje zwykle czas podróży pakietu w sieci, który może się różnić np. ze względu na błędy DNS.

-v
    Verbose output. Do not suppress DUP replies when pinging multicast address.

-V
    Wyświetla informacje o wersji i kończy działanie.

-w limit
    Określa czas (w sekundach) po jakim ping zakończy pracę niezależnie od liczby wysłanych czy odebranych pakietów. W takim przypadku ping nie wychodzi po liczbie wysłanych pakietów - czeka albo na minięcie limitu albo na liczbę otrzymanych odpowiedzi lub też na jakiś sygnał o błędzie z sieci.

-W czas-oczekiwania
    Time to wait for a response, in seconds. The option affects only timeout in absence of any responses, otherwise ping waits for two RTTs. Real number allowed with dot as a decimal separator (regardless locale setup). 0 means infinite timeout.

When using ping for fault isolation, it should first be run on the local host, to verify that the local network interface is up and running. Then, hosts and gateways further and further away should be “pinged”. Round-trip times and packet loss statistics are computed. If duplicate packets are received, they are not included in the packet loss calculation, although the round trip time of these packets is used in calculating the minimum/average/maximum/mdev round-trip time numbers.

Population standard deviation (mdev), essentially an average of how far each ping RTT is from the mean RTT. The higher mdev is, the more variable the RTT is (over time). With a high RTT variability, you will have speed issues with bulk transfers (they will take longer than is strictly speaking necessary, as the variability will eventually cause the sender to wait for ACKs) and you will have middling to poor VoIP quality.

When the specified number of packets have been sent (and received) or if the program is terminated with a SIGINT, a brief summary is displayed. Shorter current statistics can be obtained without termination of process with signal SIGQUIT.

Jeśli ping nie otrzyma w ogóle pakietów odpowiedzi zakończy się z kodem 1. Jeśli podano liczbę pakietów oraz limit i są one mniejsze niż liczba pakietów otrzymanych po osiągnięciu limitu kodem zakończenia również będzie 1. W przypadku innego błędu program wychodzi z kodem 2. W przeciwnym wypadku kończy się z kodem 0. W ten sposób można na podstawie kodu zakończenia sprawdzić czy host odpowiada, czy też nie.

Program ten jest przeznaczony do testowania sieci, pomiarów i zarządzania. Z powodu obciążenia, jakie może wywołać w sieci, niemądre jest używanie pinga podczas normalnych operacji z zautomatyzowanych skryptów.

IPV6 LINK-LOCAL DESTINATIONS

For IPv6, when the destination address has link-local scope and ping is using ICMP datagram sockets, the output interface must be specified. When ping is using raw sockets, it is not strictly necessary to specify the output interface but it should be done to avoid ambiguity when there are multiple possible output interfaces.

There are two ways to specify the output interface:

• using the % notation
    The destination address is postfixed with % and the output interface name or ifindex, for example:

    ping fe80::5054:ff:fe70:67bc%eth0

    ping fe80::5054:ff:fe70:67bc%2

• using the -I option
    When using ICMP datagram sockets, this method is supported since the following kernel versions: 5.17, 5.15.19, 5.10.96, 5.4.176, 4.19.228, 4.14.265. Also it is not supported on musl libc.

SZCZEGÓŁY PAKIETU ICMP

Nagłówek IP bez opcji ma 20 bajtów. Pakiet ICMP ECHO_REQUEST zawiera dodatkowych 8 bajtów nagłówka ICMP, za którymi następuje określona ilość danych. Gdy podany jest rozmiar-pakietu, to określa on rozmiar dodatkowego bloków danych (domyślnie 56). Tak więc ilość danych znajdujących się wewnątrz pakietu IP typu ICMP ECHO_REPLY jest zawsze 8 bajtów większa niż żądana ilość danych (nagłówek ICMP).

Jeśli rozmiar danych ma wielkość przynajmniej struktury timeval ping używa pierwszych 8 bajtów do włączania znacznika czasowego, którego używa do obliczeń czasów podróży. Jeśli podano mniej niż 8 bajtów wypełnienia, nie są podawane czasy podróży.

ZDUPLIKOWANE I USZKODZONE PAKIETY

Program ping zgłasza pakiety uszkodzone i zduplikowane. Pakiety zduplikowane nigdy nie powinny się pojawiać i prawdopodobnie są powodowane przez nieprawidłowe retransmisje poziomu połączenia (link-level). Mogą się one pojawiać w wielu sytuacjach i rzadko są dobrym znakiem, choć obecność niskiej liczby duplikatów nie musi być zawsze powodem alarmu.

Pakiety uszkodzone są oczywiście poważną przyczyną alarmu i często wskazują na uszkodzenie sprzętu na drodze pakietu ping (w sieci lub w komputerze).

UŻYWANIE RÓŻNYCH WZORCÓW DANYCH

Poziom (inter)sieci nigdy nie powinien traktować pakietów odmiennie w zależności od danych zawartych w części danych. Niestety problemy zależne od danych czasem pojawiają się w sieciach i pozostają długo niezauważane. W wielu przypadkach konkretny wzorzec powodujący problemy jest czymś, co nie posiada wystarczającej liczby "zmian", np. jest samymi jedynkami lub samymi zerami, lub wzorcem na samym krańcu, prawie wypełnionym zerami. Niekoniecznie jednak musi wystarczyć podanie wzorca z samymi zerami w wierszu poleceń, gdyż interesujący wzorzec jest na poziomie połączenia i związek między tym co się wpisze, a tym co transmituje kontroler może być złożony.

Znaczy to, że jeśli występuje problem zależny od danych, to będzie to wymagało wielu testów do jego izolacji. Jeśli ma się szczęście, można znaleźć plik, który nie może być przesłany przez sieć lub który wymaga dużo więcej czasu do przesłania niż inne podobnej długości pliki. Można następnie taki plik przetestować w poszukiwaniu powtarzalnych wzorców z użyciem opcji -p programu ping.

SZCZEGÓŁY TTL

Wartość TTL pakietu IP reprezentuje maksymalną liczbę routerów IP, którą pakiet może minąć nim zostanie wyrzucony. W obecnej sytuacji, można oczekiwać że każdy router internetowy obniży wartość TTL o jeden.

Specyfikacja TCP/IP określa, że pole TTL pakietu TCP powinno być ustawiane na 60, lecz wiele systemów używa mniejszych wartości (4.3 BSD używa 30, 4.2 używało 15).

Maksymalna możliwa wartość tego pola to 255 i większość systemów uniksowych ustawia wartość TTL pakietów ICMP ECHO_REQUEST na 255. Oto dlaczego da się pingować pewne hosty, lecz nie można ich osiągnąć poprzez telnet(1) czy ftp(1).

W normalnym działaniu, ping wypisuje wartości TTL odbieranych pakietów. Gdy system zdalny otrzymuje pakiet ping, może on zrobić jedną z trzech rzeczy z polem TTL:

    • Nie zmienić go; jest to właściwość systemów Berkeley Unix przed wydaniem 4.3BSD Tahoe. W tym wypadku wartość TTL odebranego pakietu wyniesie 255 minus liczba routerów na trasie podróży.

    • Ustawić ją na 255: jest to właściwość obecnego Berkeley Unix. W tym wypadku wartość TTL odebranego pakietu wyniesie 255 minus liczbę routerów na trasie od systemu zdalnego do hosta pingującego.

    • Ustawić na inną wartość. Niektóre komputery używają dla pakietów ICMP tej samej wartości co dla pakietów TCP, np. 30 lub 60. Inne mogą używać jeszcze bardziej abstrakcyjnych wartości.

BŁĘDY

    • Wiele hostów i bram ignoruje opcję RECORD_ROUTE.

    • Maksymalna długość nagłówka IP jest zbyt mała dla całkowitej użyteczności opcji w rodzaju RECORD_ROUTE. Jednak nie można z tym praktycznie nic zrobić.

    • Szybkie pingowanie nie jest ogólnie zalecanie, a w szczególności pingowanie adresu rozgłoszeniowego powinno być wykonywane w ściśle kontrolowanych warunkach.

ZOBACZ TAKŻE

ip(8), ss(8).

HISTORIA

Komenda ping pojawiła się w 4.3BSD.

Niniejsza wersja jest jej następcą charakterystycznym dla Linuksa.

As of version s20150815, the ping6 binary doesn't exist anymore. It has been merged into ping. Creating a symlink named ping6 pointing to ping will result in the same functionality as before.

BEZPIECZEŃSTWO

ping requires CAP_NET_RAW capability to be executed 1) if the program is used for non-echo queries (see -N option) or when the identification field set to 0 for ECHO_REQUEST (see -e), or 2) if kernel does not support ICMP datagram sockets, or 3) if the user is not allowed to create an ICMP echo socket. The program may be used as set-uid root.

DOSTĘPNOŚĆ

ping is part of iputils package.

TŁUMACZENIE
Autorami polskiego tłumaczenia niniejszej strony podręcznika są: Przemek Borys <pborys@dione.ids.pl> i Michał Kułach <michal.kulach@gmail.com>

Niniejsze tłumaczenie jest wolną dokumentacją. Bliższe informacje o warunkach licencji można uzyskać zapoznając się z GNU General Public License w wersji 3 (https://www.gnu.org/licenses/gpl-3.0.html) lub nowszej. Nie przyjmuje się ŻADNEJ ODPOWIEDZIALNOŚCI.

Błędy w tłumaczeniu strony podręcznika prosimy zgłaszać na adres listy dyskusyjnej manpages-pl-list@lists.sourceforge.net.